diff --git a/src/MQTTPacket.c b/src/MQTTPacket.c
index 9d2d8237..ce548107 100644
--- a/src/MQTTPacket.c
+++ b/src/MQTTPacket.c
@@ -843,9 +843,10 @@ int MQTTPacket_send_publish(Publish* pack, int dup, int qos, int retained, netwo
 	if (rc != TCPSOCKET_INTERRUPTED)
 		free(topiclen);
 	if (qos == 0)
-		Log(LOG_PROTOCOL, 27, NULL, net->socket, clientID, retained, rc);
+		Log(LOG_PROTOCOL, 27, NULL, net->socket, clientID, retained, rc, pack->payloadlen,
+				min(20, pack->payloadlen), pack->payload);
 	else
-		Log(LOG_PROTOCOL, 10, NULL, net->socket, clientID, pack->msgId, qos, retained, rc,
+		Log(LOG_PROTOCOL, 10, NULL, net->socket, clientID, pack->msgId, qos, retained, rc, pack->payloadlen,
 				min(20, pack->payloadlen), pack->payload);
 	FUNC_EXIT_RC(rc);
 	return rc;
diff --git a/src/MQTTProtocolClient.c b/src/MQTTProtocolClient.c
index 2325fcdb..84a2ef9b 100644
--- a/src/MQTTProtocolClient.c
+++ b/src/MQTTProtocolClient.c
@@ -1,5 +1,5 @@
 /*******************************************************************************
- * Copyright (c) 2009, 2019 IBM Corp.
+ * Copyright (c) 2009, 2020 IBM Corp.
  *
  * All rights reserved. This program and the accompanying materials
  * are made available under the terms of the Eclipse Public License v1.0
@@ -279,7 +279,7 @@ int MQTTProtocol_handlePublishes(void* pack, int sock)
 	client = (Clients*)(ListFindItem(bstate->clients, &sock, clientSocketCompare)->content);
 	clientid = client->clientID;
 	Log(LOG_PROTOCOL, 11, NULL, sock, clientid, publish->msgId, publish->header.bits.qos,
-					publish->header.bits.retain, min(20, publish->payloadlen), publish->payload);
+					publish->header.bits.retain, publish->payloadlen, min(20, publish->payloadlen), publish->payload);
 
 	if (publish->header.bits.qos == 0)
 		Protocol_processPublication(publish, client);
diff --git a/src/Messages.c b/src/Messages.c
index c54ade57..592a57cc 100644
--- a/src/Messages.c
+++ b/src/Messages.c
@@ -1,5 +1,5 @@
 /*******************************************************************************
- * Copyright (c) 2009, 2013 IBM Corp.
+ * Copyright (c) 2009, 2020 IBM Corp.
  *
  * All rights reserved. This program and the accompanying materials
  * are made available under the terms of the Eclipse Public License v1.0
@@ -46,8 +46,8 @@ static const char *protocol_message_list[] =
 	"%d %s -> SUBACK msgid: %d (%d)", /* 7, was 40 */
 	"%d %s <- UNSUBSCRIBE msgid: %d", /* 8, was 41 */
 	"%d %s -> UNSUBACK msgid: %d (%d)", /* 9 */
-	"%d %s -> PUBLISH msgid: %d qos: %d retained: %d (%d) payload: %.*s", /* 10, was 42 */
-	"%d %s <- PUBLISH msgid: %d qos: %d retained: %d payload: %.*s", /* 11, was 46 */
+	"%d %s -> PUBLISH msgid: %d qos: %d retained: %d rc %d payload len(%d): %.*s", /* 10, was 42 */
+	"%d %s <- PUBLISH msgid: %d qos: %d retained: %d payload len(%d): %.*s", /* 11, was 46 */
 	"%d %s -> PUBACK msgid: %d (%d)", /* 12, was 47 */
 	"%d %s -> PUBREC msgid: %d (%d)", /* 13, was 48 */
 	"%d %s <- PUBACK msgid: %d", /* 14, was 49 */
@@ -63,7 +63,7 @@ static const char *protocol_message_list[] =
 	"%d %s <- UNSUBACK msgid: %d", /* 24, was 74 */
 	"%d %s -> UNSUBSCRIBE msgid: %d (%d)", /* 25, was 106 */
 	"%d %s <- CONNECT", /* 26 */
-	"%d %s -> PUBLISH qos: 0 retained: %d (%d)", /* 27 */
+	"%d %s -> PUBLISH qos: 0 retained: %d rc: %d payload len(%d): %.*s", /* 27 */
 	"%d %s -> DISCONNECT (%d)", /* 28 */
 	"Socket error for client identifier %s, socket %d, peer address %s; ending connection", /* 29 */
 };
